// generation de bruit de Worley
// PC mars 2020

int DIV = 6; // nb de cases de la grille qui divise l'image
float FPMEAN = 4.0; // nb moyen de "feature point" dans une case

ArrayList<FeaturePoint> FPs = new ArrayList<FeaturePoint>();

class FeaturePoint{
  int x,y;
  FeaturePoint(int xcell, int ycell, float cellw, float cellh){
    x = int(random(xcell,xcell+cellw));
    y = int(random(ycell,ycell+cellh));
    stroke(255,0,0);strokeWeight(3);
    point(x,y);
  }
  int distance(int px, int py){
    return (x-px)*(x-px)+(y-py)*(y-py);
  }
}

int Poisson(float lambda) {
 float w = random(0,1);
 int k = 0;
 float lim = exp(-lambda);
 while (w>lim){
   w *= random(0,1); k++;
 }
 return k;
}

void setup(){
  size(600,600);
  // generation des FPs
  float cellw = float(width)/DIV;
  float cellh = float(height)/DIV;
  for (int i=0;i<DIV;i++)
   for (int j=0;j<DIV;j++){
    int xc = int(i*cellw);
    int yc = int(j*cellh);
    int nfp = Poisson(FPMEAN);
    for (int k=0;k<nfp;k++){
      FPs.add(new FeaturePoint(xc,yc,cellw,cellh));
    }     
   }
  // parcourt des pixels de l'image
  for (int i=0;i<width;i++)
   for (int j=0;j<height;j++){
    float dmin = width*width;
    float ddeux = width*width;
    for (int f=0;f<FPs.size();f++){
     float d = FPs.get(f).distance(i,j);
     if (d < dmin) dmin=d;
     else if (d < ddeux) ddeux =d;
    }
    // CHOIX REGLE LEVEL SELON RESULTAT SOUHAITE
    float level = map(dmin,0,4000,0,255);
    //float level = map(ddeux,0,8000,0,255);
    //float level = map(ddeux-dmin,0,4000,0,255);
    //float level = map(ddeux*dmin,0,4000*1000,0,255);
    stroke(level);
    point(i,j);
   }
  // enregistrement
  save("worley.png");
}
